package cs108;

import java.util.Collection;
import java.util.Comparator;
import java.util.List;
import java.util.Set;

public final class Example {
    public static void main(String[] args) {
        System.out.printf("Il y a en tout %d annonces possibles, qui sont :%n", Meld.ALL.size());
        for (Meld m : Meld.ALL)
            System.out.printf("  %s%n", m);

        List<Card> hand = List.of(
                Card.SIX_OF_SPADE,
                Card.SEVEN_OF_SPADE,
                Card.EIGHT_OF_SPADE,
                Card.NINE_OF_SPADE,
                Card.NINE_OF_HEART,
                Card.KING_OF_HEART,
                Card.NINE_OF_DIAMOND,
                Card.ACE_OF_DIAMOND,
                Card.NINE_OF_CLUB);

        System.out.printf("%nMain d'exemple : %n  %s%n", hand);

        Collection<Meld> allMelds = Meld.allIn(hand);
        System.out.printf("%nCette main contient %d annonces individuelles, qui sont :%n", allMelds.size());
        for (Meld m : allMelds)
            System.out.printf("  %s%n", m);

        System.out.printf("%nL'ensemble des parties de ces annonces est :%n");
        for (Set<Meld> m : Sets.powerSet(allMelds))
            System.out.printf("  %s%n", m);

        System.out.printf("%nLes ensembles d'annonces valides parmi celles ci-dessus sont :%n");
        // TODO: à compléter (exercice 3)
    }
}
