package cs108;

import cs108.Card.Color;
import cs108.Card.Rank;

import java.util.*;

public final class Meld {
    public static List<Meld> ALL = computeAll();

    private static List<Meld> computeAll() {
        List<Meld> all = new ArrayList<>();
        addAllQuartetsInto(all);
        addAllSuitsInto(all);
        return Collections.unmodifiableList(all);
    }

    private static int quartetPoints(Rank rank) {
        switch (rank) {
            case NINE:
                return 150;
            case JACK:
                return 200;
            case TEN:
            case QUEEN:
            case KING:
            case ACE:
                return 100;
            default:
                throw new Error();
        }
    }

    private static void addAllQuartetsInto(List<Meld> melds) {
        // TODO: à faire (exercice 1)
    }

    private static int suitPoints(int size) {
        switch (size) {
            case 3:
                return 20;
            case 4:
                return 50;
            case 5:
                return 100;
            default:
                throw new Error();
        }
    }

    private static void addAllSuitsInto(List<Meld> melds) {
        // TODO: à faire (exercice 1)
    }

    public static List<Meld> allIn(Collection<Card> hand) {
        // TODO: à faire (exercice 1)
        throw new Error("à faire");
    }

    private final Set<Card> cards;
    private final int points;

    private Meld(Set<Card> cards, int points) {
        if (!(0 < points))
            throw new IllegalArgumentException("invalid points: " + points);

        this.cards = Set.copyOf(cards);
        this.points = points;
    }

    public Set<Card> cards() {
        return cards;
    }

    public int points() {
        return points;
    }

    @Override
    public String toString() {
        return String.format("%3d: %s", points, cards);
    }
}
