package cs108;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

public final class Sets {
    private Sets() {
    }

    public static <T> Collection<Set<T>> powerSet(Collection<T> set) {
        if (set.isEmpty())
            return Set.of(Set.of());

        T firstElement = set.iterator().next();
        Set<T> subset = new HashSet<>(set);
        subset.remove(firstElement);
        Collection<Set<T>> subPowerSet = powerSet(subset);
        Set<Set<T>> powerSet = new HashSet<>();
        for (Set<T> s : subPowerSet) {
            Set<T> s1 = new HashSet<>(s);
            s1.add(firstElement);
            powerSet.add(s);
            powerSet.add(s1);
        }
        return powerSet;
    }

    public static <T> boolean mutuallyDisjoint(Collection<Set<T>> sets) {
        // TODO: à faire (exercice 2)
        throw new Error("à faire");
    }
}
